/*------------------------------------------------------------
   Texel	(www.texel.fr.fm)		2001
   DirectInput8
   Le joystick    
  ------------------------------------------------------------*/

#define INITGUID
#include <windows.h>
#include <stdio.h>
#include<math.h>
#include<dinput.h>

#pragma comment( lib, "dinput8.lib" )		// pour linker les librairies						
#pragma comment( lib, "winmm.lib" )								

HINSTANCE hGlobInstance;


// initialisation de la position de la balle
int ballx=300;
int bally=220;

int speed=10;		// vitesse de la balle
double ballstep=0;	// distance  dplac entre chaque image de la balle

LPDIRECTINPUT8 lpDI;	// objet DirectInput
LPDIRECTINPUTDEVICE8 pJoystick;	// pour le clavier


LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL CALLBACK EnumJoysticksCallback( const DIDEVICEINSTANCE* pdidInstance,
                                     VOID* pContext );


/********************* libration des objets *****************/
void Cleanup()
{
	// clavier
	pJoystick->Unacquire();
	pJoystick->Release();
	pJoystick=NULL;

	// objet Dinput
	lpDI->Release();
}

/****************** Initialisation de DirectInput **********************/
BOOL DInput_init(HINSTANCE hInstance,HWND hwnd)
{
    

    // cration de l'objet DirectInput
    if(DirectInput8Create( hInstance, DIRECTINPUT_VERSION, 
                           IID_IDirectInput8, (VOID**)&lpDI, NULL )!=DI_OK)
        return FALSE;

	// Appel d'un fonction callback pour numrer les joysticks installs et branchs
    if( lpDI->EnumDevices( DI8DEVCLASS_GAMECTRL, 
                                         EnumJoysticksCallback,
                                         NULL, DIEDFL_ATTACHEDONLY )!=DI_OK )
        return FALSE;

	// aucain joystick install et branch
    if( NULL == pJoystick )
    {
        MessageBox( NULL, "Joystick non trouv. L'application va se termin.", 
                    "DirectInput Sample", 
                    MB_ICONERROR | MB_OK );
      
        return FALSE;
    }

	// dfinition du format de donn
    if( pJoystick->SetDataFormat( &c_dfDIJoystick2 )!=DI_OK )
        return FALSE;

	// dfinition du niveau de coopration
    if( pJoystick->SetCooperativeLevel( hwnd, DISCL_EXCLUSIVE | DISCL_FOREGROUND )!=DI_OK)
        return FALSE;
	
	
	DIPROPRANGE diprg; // structure qui contient les proprits de l'tendue sur l'axe X et Y
    diprg.diph.dwSize       = sizeof(DIPROPRANGE); 
    diprg.diph.dwHeaderSize = sizeof(DIPROPHEADER); 
    diprg.diph.dwHow        = DIPH_BYOFFSET;	// pour utiliser un format de donn pour dwObj	 
    diprg.diph.dwObj        = DIJOFS_X; // axe  configur (X)
    diprg.lMin              = -12;	// tendue sur l'axe X
    diprg.lMax              = +12;	// (nombre de points de contrles)

	// on affecte ces proprits  l'interface du joystick
	if(pJoystick->SetProperty( DIPROP_RANGE, &diprg.diph )!=DI_OK)
		return FALSE;
	
	// configure l'axe Y ( les autres membres de la structure sont identiques)
	diprg.diph.dwObj        = DIJOFS_Y; // axe  configur (Y)
	// on affecte ces proprits  l'interface
	if(pJoystick->SetProperty( DIPROP_RANGE, &diprg.diph )!=DI_OK)
		return FALSE;
	

	DIPROPDWORD dipdw;	// structure qui contient la zone de neutralit sur l'axe X et Y
	dipdw.diph.dwSize       = sizeof(DIPROPDWORD); 
    dipdw.diph.dwHeaderSize = sizeof(DIPROPHEADER); 
    dipdw.diph.dwHow        = DIPH_BYOFFSET; 	// pour utiliser un format de donn pour dwObj	 
    dipdw.diph.dwObj        = DIJOFS_X; // axe  configur (X)
	dipdw.dwData			=100;	// valeur  partir de laquelle les entre sont dtects

	// affectation des proprits  l'interface
	if(pJoystick->SetProperty( DIPROP_DEADZONE, &dipdw.diph )!=DI_OK)
		return FALSE;
	// idem pour l'axe Y
	dipdw.diph.dwObj        = DIJOFS_Y; // Specify the enumerated axis
	// affectation des proprits  l'interface
	if(pJoystick->SetProperty( DIPROP_DEADZONE, &dipdw.diph )!=DI_OK)
		return FALSE;

    return TRUE;
}


/******************* enumration des joystiques prsents **********************/
BOOL CALLBACK EnumJoysticksCallback( const DIDEVICEINSTANCE* pdidInstance,VOID* pContext )
{
    // on obtient une interface vers le joystick numr.
    if(lpDI->CreateDevice( pdidInstance->guidInstance, &pJoystick, NULL)!=DI_OK)
		return DIENUM_CONTINUE;

    return DIENUM_STOP;
}



/**************** mise  jours de la position de la ball ****************/
void UpdateInputState()
{
    DIJOYSTATE2 js;           // pour stocker les donns du joystick (position...)
	HRESULT hr;		
	memset(&js,0,sizeof(DIJOYSTATE2));	// a vite les problmes
  
    hr = pJoystick->Poll(); 
    if( FAILED(hr) )	// l'accs au joystick est perdu  
    {
        hr = pJoystick->Acquire();
        while( hr == DIERR_INPUTLOST ) // on attend que le joystick soit disponnible
            hr = pJoystick->Acquire();
    }

   // on rcupre les donns du joystick dans la structure
    if( FAILED( hr = pJoystick->GetDeviceState( sizeof(DIJOYSTATE2), &js ) ) )
        pJoystick->GetDeviceState( sizeof(DIJOYSTATE2), &js ); 

	ballx+=js.lX;	//mise  jours de l'abssice
		if (ballx<=0)	ballx=0;
		if (ballx>=600)	ballx=600;
	bally+=js.lY;	//mise  jours de l'ordonne
		if (bally>=420)	bally=420;
		if (bally<=0)	bally=0;
	if(js.rgbButtons[0] & 0x80)
		PlaySound ("SONG1", hGlobInstance ,  SND_ASYNC) ;

}





int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     static CHAR szAppName[] ="Salut" ;
     HWND         hwnd ;
     MSG          msg ;
	 hGlobInstance=hInstance;
     WNDCLASS     wndclass ;
	

	 wndclass.style         = NULL;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH) ;
     wndclass.lpszMenuName  = NULL ;
     wndclass.lpszClassName = szAppName ;

     if (!RegisterClass (&wndclass))
     {
          MessageBox (NULL, TEXT ("Problme!"),szAppName, MB_ICONERROR) ;
          return 0 ;
     }
     hwnd = CreateWindow (szAppName,                  // nom de la classe
                          "Texel - DirectInput8: Joystick",		  // titre de la fentre
                           WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU
									| WS_MINIMIZEBOX | WS_VISIBLE ,   // style de la fentre
                          CW_USEDEFAULT,              // position initiale en x
                          CW_USEDEFAULT,              // position initiale en y
                          640,						  // largeur initiale
                          480,						  // hauteur initiale
                          NULL,                       // handle de la fentre mre
                          NULL,                       // handle du menu de la fentre
                          hInstance,                  // handle de l'instance
                          NULL) ;                     // paramtres de cration
     
     ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;

	 if(DInput_init(hInstance,hwnd)==FALSE){
	
		pJoystick=NULL;

		// objet Dinput
		lpDI->Release();
		 return FALSE;
		
	 }

	// dclaration et initialisation des constante pour le compteur
	DWORD temps_maintenant;      // temps courant
	DWORD  temps_fps=16;			// ms par image
	DWORD temps_suivant=0;		// temps pour rendre la prochane image
	DWORD temps_precedent=0;	    // temps de l'image prcdente image
	double temps_ecoule;			// temps coul depuis le dernier rendu
	double temps_echelle=0.05;		// chelle pour pouvoir utiliser une valeur entire pour speed

	// on sauvegarde l'heure maintenant dans suivant pour que temps_maintenant soit < que temps_suivant
	temps_suivant=GetTickCount();
	
	// sauvegarde du temps de la dernire frame
	temps_precedent=temps_suivant;


     while (1) { 
	
		if (PeekMessage( &msg, NULL, 0, 0, PM_REMOVE)) { 
			if (msg.message==WM_QUIT)	// pour quitter la boucle
				break; 
			TranslateMessage(&msg);
			DispatchMessage(&msg); 
		} else {		// aucain message!
		
			temps_maintenant=GetTickCount();		// quelle heure est-il ?
	
			// Si il est temps d'afficher la nouvelle frame 
			if (temps_maintenant>temps_suivant) { 
				temps_ecoule=(temps_maintenant-temps_precedent)*temps_echelle;
				temps_precedent=temps_maintenant;	// pour le prochain passage dans la boucle
				ballstep=speed*temps_ecoule;	    // corrige les faible retard
			
				
				UpdateInputState();				// on calcule les nouvelles coordonnes de la balle
				InvalidateRect(hwnd,NULL,TRUE);	    // on demande  redessiner la fentre
				temps_suivant = temps_maintenant + temps_fps; // pour la prochain passage de la boucle
			}		
		}
	 }

     return msg.wParam ;
}


/******************************** procdure de fentre ***********************/
LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hbitmap;		// pour le bitmap
	

     switch (message)
     {

	 case WM_CREATE:
		 // on charge le bitmap une seule fois
		 hbitmap=(HBITMAP) LoadImage(NULL,"image.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		 break;

   	 case WM_KEYDOWN:
		 switch(wParam)
		 {
			 
			case VK_ESCAPE:		// touche echap pour quitter
				DestroyWindow(hwnd);
				break;
			default:
				break;
			
		 }
		 break;

	case WM_ACTIVATE:	// notre application est active (fentre slectionn)
            if( WA_INACTIVE != wParam && pJoystick )
            {
                // on reprend le contrle du joystick 
                pJoystick->Acquire();
            }
			break;

	case WM_PAINT:	// on affiche l'image au coordonnes dja calcules
				HDC hdc;HDC hdcMemory;
				PAINTSTRUCT ps;
				hdc=BeginPaint(hwnd,&ps);	// obtient un handle de contexte de priphrique
			    
				static BITMAP bm;
				hdcMemory=CreateCompatibleDC(NULL); 
				SelectObject(hdcMemory,hbitmap);
				GetObject(hbitmap,sizeof(bm),&bm); 
				BitBlt(hdc,ballx,bally,bm.bmWidth,bm.bmHeight,hdcMemory,0,0,SRCCOPY);				
		
				DeleteDC(hdcMemory);
				EndPaint(hwnd,&ps); 	// libre un handle de contexte de priphrique
				break;

     case WM_DESTROY:
		  DeleteObject(hbitmap);
		  Cleanup();		// ne surtout pas l'oublier
          PostQuitMessage (0) ;
          return 0 ;
	
    }
    return DefWindowProc (hwnd, message, wParam, lParam);

}
